package graph;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.Scanner;

public class Shell {

	public static void main(String[] args) {

		Graph graph = new Graph();
		int cities = 0;
		int highways;
		Scanner scanner = null;

		try {
			
			scanner = new Scanner(new File("graph.in"));
			cities = scanner.nextInt();
			
			if(cities < 2 || cities > 300) {
				
				return;
			}

			highways = scanner.nextInt();
			graph.addVertices(highways);

			int firstCity;
			int secondCity;
			int distance;
			int counter = 1;
			
			while(counter <= highways) {
				
				firstCity = scanner.nextInt();
				secondCity = scanner.nextInt();
				distance = scanner.nextInt();

				if(distance < 1 || distance > 1000) {
					
					return;
				}

				graph.addEdge(firstCity, secondCity, counter, distance);
				graph.addEdge(secondCity, firstCity, counter, distance);
				counter++;
			}

			int[][] currentMatrix = new int[cities][cities];
			graph.setMatrix(currentMatrix);

			for(int i = 0; i < cities; i++) {
				for(int j = 0; j < cities; j++) {
					graph.getMatrix()[i][j] = scanner.nextInt();

					if (i == j && graph.getMatrix()[i][j] != 0) {

						return;

					} else if (i > j && graph.getMatrix()[i][j] != graph.getMatrix()[j][i]) {

						return;
					}
				}
			}
		} catch (Exception e) {
			
			return;
		} finally {
			
			scanner.close();
		}

		ArrayList<Integer> output = new ArrayList<Integer>();
		graph.execute(graph.getVertices().get(1));
		int currentDestination = 2;
		
		while(currentDestination <= cities) {
			
			LinkedList<Vertex> path = graph.getPath(graph.getVertices().get(currentDestination));

			for(int p = 0; p < path.size() - 1; p++) {
				for(Edge e : graph.getEdges()) {
					if (e.getFirstVertex() == path.get(p) && e.getSecondVertex() == path.get(p + 1)) {
						if (!(output.contains(e.getID()))) {
							
							output.add(e.getID());
						}
					}
				}
			}
			
			currentDestination++;
		}

		BufferedWriter writeInFile = null;
		
		try {
			
			writeInFile = new BufferedWriter(new FileWriter("graph.out"));
			int counter = 0;
			
			while(counter < output.size()) {
					
				writeInFile.write((output.get(counter)) + "\n");
				counter++;
			}
		} catch (IOException e) {
			
			return;
		} finally {
			try {
				if (writeInFile != null)
					writeInFile.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
}